/*
  Lithium 0.1

  Copyright (C) 2001 Teti Paolo.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  (LICENSE file) along with this program; if not, write to
  the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/


/**
 *
 * ControlThread.java
 *
 *
 *
 * @author Paolo Teti
 * @version 0.1
 */

package lithium2;

import java.rmi.*;
import java.util.Vector;


class ControlThread extends Thread
{
    private boolean end = true;
    int im = 0;
    LithiumTaskPool taskPool;
    TaskItem[] tmpVal;

    ControlThread(int whoim, String host, Vector skel,
                  LithiumTaskPool tp) throws Exception
    {
        im = whoim;
        Ske.slave[im] = (LithiumInterface)
            Naming.lookup("rmi://"+host+"/LithiumWorker");
        Ske.slave[im].setRemoteWorker(skel);
        taskPool = tp;
    }


    // Preleva un task dal task pool,
    // avvia la computazione e mem. il risultato

    public void run()
    {
	// System.out.println("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa\n");
        try {
            // System.out.println(" Flag End ...\n" + end);
            // System.out.println(" taskPool Vuoto ...\n" + taskPool.isEmpty());
            while (!taskPool.isEmpty() && end)
                {


		    // System.out.println("Porca troia ---> " +
		    //		       ((Integer)((TaskItem)tmpVal[0]).
		    //			dataTask).
		    //		       intValue());
		    //Ske.slave[im].execute(null);

		    tmpVal = (TaskItem[])taskPool.getTask();

		    taskPool.addTask(Ske.slave[im].execute(tmpVal));

		}
	}
	catch (Exception ee)
	    {
		//System.out.println("Error: " +ee);
		end = true;
	    }

    }

} // ControlThread

