/*
  Lithium 0.1

  Copyright (C) 2001 Teti Paolo.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  (LICENSE file) along with this program; if not, write to
  the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/


/**
 * If.java
 *
 *
 *
 *
 *
 * @author Paolo Teti
 * @version 0.1
 */

package lithium2;

public class If extends JSkeletons
{
    JSkeletons Worker1 = null;
    JSkeletons Worker2 = null;
    Condition ifCondition = null;


    /**
     * The If skeleton
     *
     * @param c  The If condition
     * @param w1 The Skeleton that will be executed if the boolean
     * condition is <b> true </b>.
     * @param w2 The Skeleton that will be executed if the boolean
     * condition is <b> false </b>.
     */
    public If(Condition c, JSkeletons w1, JSkeletons w2)
    {
	Worker1 = w1;
	Worker2 = w2;
	ifCondition = c;
    }


    Object[] getSkeletonInfo()
    {
	Object [] retValue = new Object[3];
	retValue[0] = ifCondition;
	retValue[1] = Worker1;
	retValue[2] = Worker2;
	return (retValue);
    }


    public Object run(Object task)
    {
	if (ifCondition.apply(task))
	    return (Worker1.run(task));
	else
	    return (Worker2.run(task));
    }




} // If

