/*

  Lithium 0.1

  Copyright (C) 2001 Teti Paolo.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  (LICENSE file) along with this program; if not, write to
  the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/


package lithium2;
import java.io.*;

/**
 *
 * <b>The generic abstact Skeletons class. </b>
 *
 * Create a generic skeletons
 *
 * @author Paolo Teti
 * @version 0.1
 */
public abstract class JSkeletons
    implements Serializable
{

    /**
     * You can reimplement it with the function to compute in
     * the skeletons.
     *
     * @param task The task to compute using this skeleton
     * @return The result of the computation
     */
    public abstract Object run (Object task);




    // Used by the run-time support to obtain information
    // about the skeleton.
    Object[] getSkeletonInfo() { return (null); }

} // JSkeletons


