/*
  Lithium 0.1

  Copyright (C) 2001 Teti Paolo.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  (LICENSE file) along with this program; if not, write to
  the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/

package lithium2;
import java.util.Vector;

/**
 *
 *
 * <b>The Pipeline Skeleton.</b>
 *
 *
 * @author Paolo Teti
 * @version 0.1
 */
public class Pipeline extends JSkeletons
{
    Vector pipeWorkerList = null;


    /**
     *
     * <b> Create a Pipeline Skeleton </b>
     *
     */
    public Pipeline()
    {
	pipeWorkerList = new Vector();
    }


    /**
     *
     * Add a worker to the set of Pipeline worker.
     *
     *
     * @param pipeWorker A generic skeleton compisitions to add
     * to the set of Pipeline worker.
     */
    public void addWorker(JSkeletons pipeWorker)
    {
	pipeWorkerList.add(pipeWorker);
    }



    Object[] getSkeletonInfo()
    {
	JSkeletons[] ret = new JSkeletons[pipeWorkerList.size()];

	for (int i=0;i<ret.length;i++)
	    ret[i] = (JSkeletons)pipeWorkerList.elementAt(i);

	return ((JSkeletons[])ret);

	//return (pipeWorkerList.toArray());
    }


    /**
     * Execute the skeleton in sequenzial mode.
     * (i.e like a sequential skeleton)
     *
     * @param task The task to compute.
     * @return The result of the computation.
     */
    public Object run(Object task)
    {
	Object actualTask = task;

	for (int k=0;k<pipeWorkerList.size();k++)
	    actualTask = ((JSkeletons)pipeWorkerList.
			  elementAt(k)).run(actualTask);

	return (actualTask);
    }

} // Pipeline


