/*

  Lithium 0.1

  Copyright (C) 2001 Teti Paolo.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  (LICENSE file) along with this program; if not, write to
  the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/


package lithium2;
import java.io.*;

/**
 *
 * <b>The generic abstact Recomp class. </b>
 *
 * Create a Recomp Rule
 *
 * @author Paolo Teti
 * @version 0.1
 */
public abstract class Recomp implements Serializable
{

    /**
     * You can reimplement it with the rule's algorithm.
     *
     * @param task The task to compute using this rule
     * @return The result of the computation
     */
    public abstract Object run (Object[] task);

    public abstract int size();

} // Divide


